package de.flothow.prog3.netclient;

import java.io.*;
import java.net.Socket;

public class NetClient implements Runnable {
	static BufferedReader netIn;
	static BufferedWriter netOut;
	static BufferedReader cIn;
	static Socket sock;
	
	public static void main(String[] args) throws Exception {
		// Verbinden
		sock = new Socket(args[0], Integer.parseInt(args[1]));
		netIn = new BufferedReader(new InputStreamReader(sock.getInputStream()));
		netOut = new BufferedWriter(new OutputStreamWriter(sock.getOutputStream()));
		System.out.println("*** socket " + sock + " connected ***");
		
		cIn = new BufferedReader(new InputStreamReader(System.in));
		
		// Thread für Empfang starten
		Thread t = new Thread(new NetClient());
		t.start();
		
		// Konsoleneingaben senden
		String line;
		while ((line = cIn.readLine()) != null) {
			netOut.write(line + "\n");
			netOut.flush();
		}
		
		System.out.println("*** closing send stream ***");		
		sock.shutdownOutput();
		
		// Warten bis Empfangsthread auch fertig ist, dann Socket schließen
		t.join();
		System.out.println("*** closing socket ***");		
		sock.close();
	}

	
	// run-Methode für den Empfangsthread
	@Override
	public void run() {
		try {
			String line;
			while ((line = netIn.readLine()) != null) {
				System.out.println(line);
			}
			
			System.out.println("*** end of receive stream ***");		
			sock.shutdownInput();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
